import { type Config } from '@pnpm/config';
import { type CreateStoreControllerOptions } from '@pnpm/store-connection-manager';
import { type IncludedDependencies, type Project, type ProjectManifest, type ProjectsGraph } from '@pnpm/types';
import { type UpdateMatchingFunction } from '@pnpm/core';
import { type PreferredVersions } from '@pnpm/resolver-base';
type RecursiveOptions = CreateStoreControllerOptions & Pick<Config, 'bail' | 'dedupePeerDependents' | 'depth' | 'globalPnpmfile' | 'hoistPattern' | 'hooks' | 'ignorePnpmfile' | 'ignoreScripts' | 'linkWorkspacePackages' | 'lockfileDir' | 'lockfileOnly' | 'modulesDir' | 'pnpmfile' | 'rawLocalConfig' | 'registries' | 'rootProjectManifest' | 'rootProjectManifestDir' | 'save' | 'saveDev' | 'saveExact' | 'saveOptional' | 'savePeer' | 'savePrefix' | 'saveProd' | 'saveWorkspaceProtocol' | 'lockfileIncludeTarballUrl' | 'sharedWorkspaceLockfile' | 'tag'> & {
    include?: IncludedDependencies;
    includeDirect?: IncludedDependencies;
    latest?: boolean;
    pending?: boolean;
    workspace?: boolean;
    allowNew?: boolean;
    forceHoistPattern?: boolean;
    forcePublicHoistPattern?: boolean;
    ignoredPackages?: Set<string>;
    update?: boolean;
    updatePackageManifest?: boolean;
    updateMatching?: UpdateMatchingFunction;
    useBetaCli?: boolean;
    allProjectsGraph: ProjectsGraph;
    selectedProjectsGraph: ProjectsGraph;
    preferredVersions?: PreferredVersions;
    pruneDirectDependencies?: boolean;
} & Partial<Pick<Config, 'sort' | 'workspaceConcurrency'>> & Required<Pick<Config, 'workspaceDir'>>;
export declare function recursive(allProjects: Project[], params: string[], opts: RecursiveOptions, cmdFullName: 'install' | 'add' | 'remove' | 'unlink' | 'update' | 'import'): Promise<boolean | string>;
export declare function matchDependencies(match: (input: string) => string | null, manifest: ProjectManifest, include: IncludedDependencies): string[];
export type UpdateDepsMatcher = (input: string) => string | null;
export declare function createMatcher(params: string[]): UpdateDepsMatcher;
export declare function parseUpdateParam(param: string): {
    pattern: string;
    versionSpec: string | undefined;
};
export declare function makeIgnorePatterns(ignoredDependencies: string[]): string[];
export {};
